﻿namespace Battleship.CollectionGenericObjects;

/// <summary>
/// Конструктор
/// </summary>
/// <typeparam name="T"></typeparam>
public class ListGenericObjects<T> : ICollectionGenericObjects<T>
    where T : class
{
    /// <summary>
    /// Список объектов, которые храним
    /// </summary>
    private readonly List<T?> _collection;
    
    /// <summary>
    /// Максимально допустимое число объектов в списке
    /// </summary>
    private int _maxCount;

    public int Count => _collection.Count;
    public int SetMaxCount { set { if (value > 0) { _maxCount = value; } } }

    /// <summary>
    /// Конструктор
    /// </summary>
    public ListGenericObjects()
    {
        _collection = new();
    }

    public T? Get(int position)
    {
        // TODO проверка позиции
        if (position >= Count || position < 0) 
            return null;
        return _collection[position];
    }

    public int Insert(T obj)
    {
        // TODO проверка, что не превышено максимальное количество элементов
        // TODO проверка позиции
        // TODO вставка по позиции
        if (Count == _maxCount) return -1;
        _collection.Add(obj);
        return Count;
    }

    public int Insert(T obj, int position)
    {
        // TODO проверка, что не превышено максимальное количество элементов
        // TODO проверка позиции
        // TODO вставка по позиции
        if (position >= Count || position < 0)
        {
            return -1;
        }
        if (Count == _maxCount)
        {
            return -1;
        }
        _collection.Insert(position, obj);
        return position;
    }

    public T Remove(int position)
    {
        // TODO проверка позиции
        // TODO удаление объекта из списка
        if (position >= Count || position < 0) 
            return null;
        T obj = _collection[position];
        _collection.RemoveAt(position);
        return obj;
    }
}
