﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Battleship.MovementStrategy;

public class MoveToBorder : AbstractStrategy
{
    protected override bool IsTargetDestination()
    {
        var objParams = GetObjectParameters;
        if (objParams == null)
        {
            return false;
        }
        return objParams.RightBorder + GetStep() >= FieldWidth &&
        objParams.DownBorder + GetStep() >= FieldHeight;
    }

    protected override void MoveToTarget()
    {
        var objParams = GetObjectParameters;
        if (objParams == null)
        {
            return;
        }
        var diffX = objParams.RightBorder - FieldWidth;
        if (Math.Abs(diffX) > GetStep())
        {
            MoveRight();
        }
        var diffY = objParams.DownBorder - FieldHeight;
        if (Math.Abs(diffY) > GetStep())
        {
            MoveDown();
        }
    }
}
