﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Battleship.MovementStrategy;

/// <summary>
/// Стратегия перемещения объекта в центр экрана
/// </summary>
public class MoveToCenter : AbstractStrategy
{
    protected override bool IsTargetDestination()
    {
        ObjectParameters? objParams = GetObjectParameters;
        if (objParams != null )
        {
            return false;
        }

        return objParams.ObjectMiddleHorizontall - GetStep() <= FieldWidth / 2 && objParams.ObjectMiddleHorizontall + GetStep() >= FieldWidth / 2 &&
            objParams.ObjectMiddleVertical - GetStep() <= FieldHeight / 2
            && objParams.ObjectMiddleVertical + GetStep() >= FieldHeight / 2;
    }

    protected override void MoveToTarget()
    {
        ObjectParameters? objParams = GetObjectParameters;
        if (objParams == null )
        {
            return;
        }

        int diffX = objParams.ObjectMiddleHorizontall - FieldWidth / 2;
        if (Math.Abs(diffX) > GetStep())
        {
            if (diffX > 0)
            {
                MoveLeft();
            }
            else
            {
                MoveRight();
            }
        }

        int diffy = objParams.ObjectMiddleVertical - FieldHeight / 2;
        if (Math.Abs(diffy) > GetStep())
        {
            if (diffy > 0)
            {
                MoveUp();
            }
            else
            {
                MoveDown();
            }
        }
    }
}
